<?php

namespace catchAdmin\yunying\controller;

use catcher\base\CatchRequest as Request;
use catcher\CatchResponse;
use catcher\base\CatchController;
use catchAdmin\yunying\model\InsureRecords as insureRecordsModel;

class InsureRecords extends CatchController
{
    protected $insureRecordsModel;
    
    public function __construct(InsureRecordsModel $insureRecordsModel)
    {
        $this->insureRecordsModel = $insureRecordsModel;
    }
    
    /**
     * 列表
     * @time 2022年09月15日 14:19
     * @param Request $request 
     */
    public function index(Request $request) : \think\Response
    {
        return CatchResponse::paginate($this->insureRecordsModel->getList());
    }
    
    /**
     * 保存信息
     * @time 2022年09月15日 14:19
     * @param Request $request 
     */
    public function save(Request $request) : \think\Response
    {
        return CatchResponse::success($this->insureRecordsModel->storeBy($request->post()));
    }
    
    /**
     * 读取
     * @time 2022年09月15日 14:19
     * @param $id 
     */
    public function read($id) : \think\Response
    {
        return CatchResponse::success($this->insureRecordsModel->findBy($id));
    }
    
    /**
     * 更新
     * @time 2022年09月15日 14:19
     * @param Request $request 
     * @param $id
     */
    public function update(Request $request, $id) : \think\Response
    {
        return CatchResponse::success($this->insureRecordsModel->updateBy($id, $request->post()));
    }
    
    /**
     * 删除
     * @time 2022年09月15日 14:19
     * @param $id
     */
    public function delete($id) : \think\Response
    {
        return CatchResponse::success($this->insureRecordsModel->deleteBy($id));
    }
}